/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by informer-gen. DO NOT EDIT.

package v1beta1

import (
	"context"
	time "time"

	bootstrapv1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_bootstrap/bootstrap/v1beta1"
	versioned "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-bootstrap/clientset/versioned"
	internalinterfaces "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-bootstrap/informers/externalversions/internalinterfaces"
	v1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-bootstrap/listers/bootstrap/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// KubeadmConfigInformer provides access to a shared informer and lister for
// KubeadmConfigs.
type KubeadmConfigInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1beta1.KubeadmConfigLister
}

type kubeadmConfigInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewKubeadmConfigInformer constructs a new informer for KubeadmConfig type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewKubeadmConfigInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredKubeadmConfigInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredKubeadmConfigInformer constructs a new informer for KubeadmConfig type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredKubeadmConfigInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.BootstrapV1beta1().KubeadmConfigs(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.BootstrapV1beta1().KubeadmConfigs(namespace).Watch(context.TODO(), options)
			},
		},
		&bootstrapv1beta1.KubeadmConfig{},
		resyncPeriod,
		indexers,
	)
}

func (f *kubeadmConfigInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredKubeadmConfigInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *kubeadmConfigInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&bootstrapv1beta1.KubeadmConfig{}, f.defaultInformer)
}

func (f *kubeadmConfigInformer) Lister() v1beta1.KubeadmConfigLister {
	return v1beta1.NewKubeadmConfigLister(f.Informer().GetIndexer())
}
